<template>
  <div class="order-resource-select-wrapper">
     <ObAutocomplete
        v-model="value"
        :label="resourceLabel || currentResource.label"
        placeholder="Ожидание назначения"
        :theme="theme"
        is-resource
        :action-icon="actionIcon"
        :remote-opt="dropdownMethod ? dropdownMethod(resourceSuperclass) : remoteMethod()"
        :is-disabled="isClient || isDisabled"
        :is-always-action="isAlwaysAction"
        :show-clear="showClear"
        :value-exp="valueExp"
        :data-qa="resourceSuperclass + 'Resource'"
        popper-class="order-executor-select"
        @selectAction="$refs.selectResourceModal.open()"
        @input="(data) => $emit('input', data)"
      >
       <div
         slot="value"
         slot-scope="{ data }"
       >
         <template v-if="['driver'].includes(resourceSuperclass)">
           {{ data[valueExp] }}
         </template>
         <template v-else>
           <span v-html="gosNumberHtml(data)" />
         </template>
       </div>

       <div
         class="resource-description"
         v-if="descriptionExp && data[descriptionExp]"
         slot="description"
         slot-scope="{ data }"
       >
         {{ data[descriptionExp] }}
       </div>

       <div
         class="d-f jc-sb al-i-c w100 flex-grow"
         slot="item"
         slot-scope="{ data, highlight }"
         :class="data.isDisabled && '-gray-window'"
       >
         <template v-if="['driver'].includes(resourceSuperclass)">
           {{ data[valueExp] }}
         </template>
         <template v-else>
           <div
             v-html="highlight(data[descriptionExp])"
             class="item-title"
           />
           <div v-html="highlight(gosNumberHtml(data))" />
         </template>
       </div>
       <a
          v-if="value && value.uuid"
          slot="extraIcon"
          :class="isDisabled && '-gray-window'"
          :href="resourceLink"
          class="ext-link"
          target="_blank"
        >
          <i class="icon external-link -cobalt" />
        </a>

      </ObAutocomplete>
      <ObModal
        ref="selectResourceModal"
        :title="`Подбор ${currentResource.labelGenitive} от ${orgName}`"
        size="extra-large"
        custom-class="order-resource-modal"
        :is-show-controls="true"
        :is-read-only="true"
        :data-qa="resourceSuperclass + 'ResourceModal'"
      >
        <OrderResourceSelectModal
          :resource-superclass="resourceSuperclass"
          :remote-method="remoteMethod()"
          :value="value"
          :is-enabled-select="isEnabledSelect"
          @on-select="onSelect"
          @on-cancel-resource="onCancelResource"
        />
      </ObModal>
  </div>
</template>

<script>
  import api from '@/api'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObAutocomplete from 'common-components/src/obComponents/obAutocomplete'
  import OrderResourceSelectModal from './modals/orderResourceSelectModal'
  import { getResourceClassByCode } from '@/constants/order'

  export default {
    name: 'OrderResourceSelect',
    components: {
      OrderResourceSelectModal,
      ObModal,
      ObAutocomplete
    },
    props: {
      value: {
        type: Object,
        default: null
      },
      resourceLabel: {
        type: String,
        default: null
      },
      resourceSuperclass: {
        type: String,
        required: true
      },
      isClient: {
        type: Boolean,
        default: false
      },
      orgName: {
        type: String,
        default: ''
      },
      isDisabled: {
        type: Boolean,
        default: false
      },
      orderUuid: {
        type: String,
        default: null
      },
      actionIcon: {
        type: Boolean,
        default: true
      },
      isAlwaysAction: {
        type: Boolean,
        default: false
      },
      isEnabledSelect: {
        type: Boolean,
        default: true
      },
      showClear: {
        type: Boolean,
        default: true
      },
      theme: {
        type: String,
        default: 'blue'
      },
      dropdownMethod: {
        type: Function,
        default: null
      }
    },
    data () {
      return {
        api
      }
    },
    computed: {
      currentResource () {
        return getResourceClassByCode(this.resourceSuperclass) || {}
      },
      valueExp () {
        const valueExpMap = {
          driver: 'fio'
        }

        return valueExpMap[this.resourceSuperclass] || 'uuid'
      },
      descriptionExp () {
        const valueExpMap = {
          tractor: 'mark',
          trailer: 'resourceTypeTitle',
          semitrailer: 'resourceTypeTitle',
          container_truck: 'resourceTypeTitle',
          van: 'resourceTypeTitle',
          driver: 'phone',
        }

        return valueExpMap[this.resourceSuperclass] || null
      },
      resourceLink() {
        const route = this.$router.resolve(`/resources/${this.value?.uuid}`)
        return route?.href
      }
    },
    methods: {
      onSelect(data) {
        this.$refs.selectResourceModal.close()
        this.$emit('on-select',  data)
      },
      gosNumberHtml (data) {
        if (!data.grzNum) return data.number || data.uuid
        if (data.grzReg) {
          return `<div class="gos-number">
                <span class="block">${data.grzNum}</span>
                <span class="block">${data.grzReg}</span>
              </div>`
        } else {
          return `<div class="gos-number">
                <span class="block">${data.grzNum}</span>
              </div>`
        }
      },
      onCancelResource () {
        this.$refs.selectResourceModal.close()
        this.$emit('on-cancel-resource')
      },
      remoteMethod () {
        return {
          method: api.orderProcess.getResourcesList,
          arguments: {
            superclass: this.resourceSuperclass,
            orderUuid: this.orderUuid
          }
        }
      }
    }
  }
</script>

<style lang="scss">
  .ob-autocomplete, .ob-autocomplete__results, .ob-table-inner {
    .gos-number {
      display: inline-flex;
      align-items: center;
      width: 102px;
      vertical-align: top;
      border: 1px solid $cornflower-craiola;
      border-radius: 3px;
      font-size: 13px;
      line-height: 15px;
      letter-spacing: 0.2px;
      color: $components-orderExecution_gos-number;
      text-transform: lowercase;
      font-variant: small-caps;
      background: $background-white;
      .block {
        flex-grow: 2;
        height: 24px;
        padding: 5px 6px 0 6px;
        vertical-align: top;
        &:nth-child(2) {
          flex-shrink: 0;
          width: 30px;
          padding: 7px 0 0 0;
          text-align: center;
          font-size: 11px;
          line-height: 13px;
          border-left: 1px solid $cornflower-craiola;
        }
      }
    }
  }
  .resource-description{
    margin-top: 7px;
  }

  .order-executor-select {
    .item-title {
      flex-grow: 2;
      margin-right: 15px;
    }
    .flex-grow {
      flex-grow: 2;
    }
  }
  .ob-modal-container {
    .order-resource-modal {
      width: 1286px!important;
    }
  }

  .order-resource-select-wrapper {
    .ext-link {
      text-decoration: none;
      margin-left: 8px !important;
    }
    .ob-autocomplete__action--out {
      margin-left: 4px !important;
    }
    .ob-autocomplete__main .col-right i {
      font-size: 16px !important;
    }
  }
</style>
